program polstanw;

uses	Crt;

(*
  Skadnia: polstanw standard_WE standard_WY plik_WE plik_WY

  Standardy : (M)azovia, (L)atin-2, (W)indows, (D)HN, (C)SK,
	      C(Y)fromat, M(I)crovex, IS(O) Latin-2, I(E)A,
	      Lo(G)ic, (V)entura, IINTE-I(S)IS, ELWRO (J)unior,
	      Macintos(H), Amiga (P)L, Te(X) PL, Atari-Calam(U)s,
	      Corel D(R)aw!, (A)TM, (B)ez polskich znakw.

*)

type	tafnt=array[1..20,1..18] of char;

const	polskie : tafnt =
	('',
	 '䢘',
	 '󜿟ʣӌ',
	 '',
	 '',
	 '',
	 '',
	 '󶿼ʣӦ',
	 '뒝',
	 '',
	 '',
	 '',
	 '',
	 'ė',
	 '',
	 '󱻹ӑ',
	 '',
	 '󥺪ɣ',
	 '',
	 'acelnoszzACELNOSZZ');

	stand : string[20] = 'MLWDCYIOEGVSJHPXURAB';

var	plikwe,plikwy:file; bufor:array[0..255] of char;
	k,l,n:longint; BufIO:array[0..20479] of char;
	ch1,ch2:char; cg:string;

procedure zlyplik(nazwa:string);
begin
 write(#7'Nie moge otworzyc pliku ',nazwa,' !');
 halt;
end;

function czyjest(zn:char; pytciag:string; var numer:longint):boolean;
begin
 numer:=pos(zn,pytciag);
 if numer=0 then czyjest:=false else czyjest:=true;
end;

function czystd(std:char; var numer:longint):boolean;
begin
 czystd:=czyjest(std,stand,numer);
end;

procedure ustaw(stdwe,stdwy:char);
var	  l1,l2,l3:longint;
begin
 czystd(stdwe,l1);
 czystd(stdwy,l2);
 for l3:=0 to 255 do bufor[l3]:=char(l3);
 for l3:=1 to 18 do bufor[ord(polskie[l1,l3])]:=polskie[l2,l3];
end;

function czypl(zn,std:char; var numer:longint):boolean;
var	 l1:longint;
begin
 czystd(std,l1);
 numer:=pos(zn,polskie[l1]);
 if numer=0 then czypl:=false else czypl:=true;
end;

procedure pisztab(nr:byte; ciag:string);
begin
 gotoxy(nr shl 3 + 1,wherey);
 writeln(ciag);
end;

procedure blad;
begin
 pisztab(1,'Program POLSTAND for Win32 wersja 1.00. Autor: Sawomir Stachniewicz.');
 pisztab(1,'Skadnia : POLSTAND standard_WE standard_WY plik_WE plik_WY');
 writeln;
 pisztab(1,'Standardy :     (M)azovia, (L)atin II, (W)indows, (D)HN, (C)SK,');
 pisztab(3,'C(Y)fromat, M(I)crovex, IS(O) Latin II, I(E)A,');
 pisztab(3,'Lo(G)ic, (V)entura, IINTE-I(S)IS, ELWRO (J)unior,');
 pisztab(3,'Macintos(H), Amiga (P)L, Te(X) PL, Atari-Calam(U)s,');
 pisztab(3,'Corel D(R)aw!, (A)TM, (B)ez polskich znakw.');
 halt(1);
end;

begin
 if paramcount<2 then blad;
 cg:=paramstr(1);
 ch1:=upcase(cg[1]);
 cg:=paramstr(2);
 ch2:=upcase(cg[1]);
 {standardy WE i WY}

 filemode:=0;
 cg:=paramstr(3);
 assign(plikwe,cg);
 reset(plikwe,1);
 if ioresult<>0 then zlyplik(cg);

 cg:=paramstr(4);
 assign(plikwy,cg);
 rewrite(plikwy,1);
 if ioresult<>0 then zlyplik(cg);
{ jeli nie mona otworzy plikw to protest }

 if ((not czystd(ch1,k)) or (not czystd(ch2,l))) then blad;
 ustaw(ch1,ch2);

 while not eof(plikwe) do
 begin
  BlockRead(plikwe,BufIO,20480,n);
  asm
   mov ecx, n
   lea esi, BufIO
   mov edi, esi
   cld
@petla:
   xor eax, eax
   lodsb
   mov ebx, eax
   mov al, byte ptr ds:bufor[ebx]
   segds stosb
   loop @petla
  end;
  BlockWrite(plikwy,BufIO,n,n);
 end;

 close(plikwe);
 close(plikwy);

end.

